
BasicUpstart2(main)

// -------------- Constants --------------

.label XSIZE1 = 0  // The area of the drawn sprite on the left
.label XSIZE2 = 24 // The area of the drawn sprite on the right
.label YSIZE1 = 0  // The area of the drawn sprite at the top
.label YSIZE2 = 21 // The area of the drawn sprite at the bottom

.label JOYSTICK_2 = $dc00
.label JOYSTICK_2_IDLE = %01111111

.label UP 		= %00000001
.label DOWN		= %00000010
.label LEFT		= %00000100
.label RIGHT	= %00001000
.label FIRE		= %00010000

main:

gameSetup:
	
	// Set X and Y position of sprite 0

	ldx #0 // Sprite 0

	lda #100
	sta Sprite_X_Pos,x
	sta Sprite_Y_Pos,x

	// Set X and Y position of sprite 1

	ldx #1 // Sprite 1

	lda #150
	sta Sprite_X_Pos,x
	sta Sprite_Y_Pos,x

	// Set sprite 0 color
	lda #WHITE
	sta $d027

	// Set sprite 1 color
	lda #GREEN
	sta $d028

	// Set sprite pointer for sprite 0 and sprite 1
	lda #$80
	sta $07f8
	sta $07f9

	lda #%00000011 // Enable sprite 0 and sprite 1
	sta $d015

	jsr $e544 // Clear screen

gameLoop:

	jsr delay
	jsr readJoystick_2
	jsr checkCollision
	jmp gameLoop


checkCollision:

	ldx #0 // -------------------- Sprite 0 --------------------

	lda Sprite_X_Pos,x // Sprite 0 X
	sec
	sbc #XSIZE1
	sta collisionX1
	clc
	adc #XSIZE2
	sta collisionX2

	lda Sprite_Y_Pos,x // Sprite 0 Y
	sec
	sbc #YSIZE1
	sta collisionY1
	clc
	adc #YSIZE2
	sta collisionY2

	ldx #1 // -------------------- Sprite 1 --------------------

	lda Sprite_X_Pos,x // Sprite 1 X
	clc
	adc #12
 	cmp collisionX1
	bcc notHit
	cmp collisionX2
	bcs notHit

	lda Sprite_Y_Pos,x // Sprite 1 Y
	clc
	adc #10
	cmp collisionY1
	bcc notHit
	cmp collisionY2
	bcs notHit

	hit:
		inc $d020 // Increase border color
		jmp doneCollision
	notHit:
		lda #LIGHT_BLUE
		sta $d020
	doneCollision:
		rts


readJoystick_2:
	ldx #0 // Sprite 0

	lda JOYSTICK_2
	cmp #JOYSTICK_2_IDLE
	beq joy2_IDLE
			jmp checkJoy2_UP
		joy2_IDLE:

		checkJoy2_UP:
			lda JOYSTICK_2
			and #UP
			beq joy2_UP
				jmp checkJoy2_DOWN
			joy2_UP:
				dec Sprite_Y_Pos,x

		checkJoy2_DOWN:
			lda JOYSTICK_2
			and #DOWN
			beq joy2_DOWN
				jmp checkJoy2_LEFT
			joy2_DOWN:
				inc Sprite_Y_Pos,x
			
		checkJoy2_LEFT:
			lda JOYSTICK_2
			and #LEFT
			beq joy2_LEFT
				jmp checkJoy2_RIGHT
			joy2_LEFT:
				dec Sprite_X_Pos,x
			
		checkJoy2_RIGHT:
			lda JOYSTICK_2
			and #RIGHT
			beq joy2_RIGHT
				jmp checkJoy2_FIRE
			joy2_RIGHT:
				inc Sprite_X_Pos,x
			
		checkJoy2_FIRE:
			lda JOYSTICK_2
			and #FIRE
			beq joy2_FIRE
				jmp doneReadJoystick_2
			joy2_FIRE:
				inc $d027
			
	doneReadJoystick_2:
		rts


delay:
	ldx #250

	delayLoop1:
		ldy #100

		delayLoop2:
			nop
			nop
			nop
			nop
			nop

			iny
			cpy #0
			bne delayLoop2

		inx
		cpx #0
		bne delayLoop1

		// Update sprite 0 position in RAM
		ldx #0

		lda Sprite_X_Pos,x
		clc
		adc #24
		sta $d000

		lda Sprite_Y_Pos,x
		clc
		adc #50
		sta $d001

		// Update sprite 1 position in RAM
		ldx #1

		lda Sprite_X_Pos,x
		clc
		adc #24
		sta $d002

		lda Sprite_Y_Pos,x
		clc
		adc #50
		sta $d003
	rts


// -------------- Variables --------------

collisionX1: .byte 0
collisionX2: .byte 0
collisionY1: .byte 0
collisionY2: .byte 0


// -------------- Tables --------------

Sprite_X_Pos:
.byte 0
.byte 0

Sprite_Y_Pos:
.byte 0
.byte 0


*=$2000 "Sprites"
.import binary "sprites.bin"
